import uuid
from typing import List

from sziszapangma.model.model import Word, SingleAnnotation, AnnotationType, SpanAnnotation, \
    Document


def _get_uuid() -> str:
    return str(uuid.uuid4())


def create_new_word(text: str) -> Word:
    return Word(id=_get_uuid(), type='Word', text=text)


def create_new_single_annotation(
    annotation_type: AnnotationType,
    value: any,
    reference_id: str
) -> SingleAnnotation:
    return SingleAnnotation(id=_get_uuid(), type=annotation_type, value=value,
                            reference_id=reference_id)


def create_new_span_annotation(name: str, elements: List[str]) -> SpanAnnotation:
    return SpanAnnotation(id=_get_uuid(), type='SpanAnnotation', name=name, elements=elements)


def create_new_document(word_ids: List[str]) -> Document:
    return Document(id=_get_uuid(), type='Document', word_ids=word_ids)
